// Code generated by github.com/99designs/gqlgen, DO NOT EDIT.

package generated

import (
	"bytes"
	"context"
	"errors"
	"sync/atomic"

	"github.com/99designs/gqlgen/graphql"
	"github.com/99designs/gqlgen/graphql/introspection"
	gqlparser "github.com/vektah/gqlparser/v2"
	"github.com/vektah/gqlparser/v2/ast"
	"gitlab.com/talgat.s/belka-go/graph/model"
)

// NewExecutableSchema creates an ExecutableSchema from the ResolverRoot interface.
func NewExecutableSchema(cfg Config) graphql.ExecutableSchema {
	return &executableSchema{
		schema:     cfg.Schema,
		resolvers:  cfg.Resolvers,
		directives: cfg.Directives,
		complexity: cfg.Complexity,
	}
}

type Config struct {
	Schema     *ast.Schema
	Resolvers  ResolverRoot
	Directives DirectiveRoot
	Complexity ComplexityRoot
}

type ResolverRoot interface {
	Mutation() MutationResolver
	Query() QueryResolver
	Subscription() SubscriptionResolver
}

type DirectiveRoot struct {
	AllowAccess func(ctx context.Context, obj interface{}, next graphql.Resolver, roles []model.Role) (res interface{}, err error)
}

type ComplexityRoot struct {
	BotPlayer struct {
		ID   func(childComplexity int) int
		Name func(childComplexity int) int
	}

	Card struct {
		Rank func(childComplexity int) int
		Suit func(childComplexity int) int
	}

	Game struct {
		ID     func(childComplexity int) int
		Teams  func(childComplexity int) int
		Winner func(childComplexity int) int
	}

	Hand struct {
		Cards  func(childComplexity int) int
		Player func(childComplexity int) int
	}

	Lap struct {
		ID func(childComplexity int) int
	}

	Move struct {
		Card   func(childComplexity int) int
		ID     func(childComplexity int) int
		Player func(childComplexity int) int
	}

	Mutation struct {
		CreateGame     func(childComplexity int) int
		Login          func(childComplexity int, email string, password string) int
		Move           func(childComplexity int, gameID string, card *model.InputCard) int
		Ping           func(childComplexity int) int
		PingAuthorized func(childComplexity int) int
		RefreshToken   func(childComplexity int, refreshToken string) int
		Register       func(childComplexity int, email string, password string) int
		StartGame      func(childComplexity int, gameID string) int
	}

	PlayerSuit struct {
		Player func(childComplexity int) int
		Suit   func(childComplexity int) int
	}

	Query struct {
		GetUser        func(childComplexity int, id *string) int
		Hands          func(childComplexity int, gameID string) int
		Ping           func(childComplexity int) int
		PingAuthorized func(childComplexity int) int
	}

	Round struct {
		ID          func(childComplexity int) int
		TeamsPoints func(childComplexity int) int
		Winner      func(childComplexity int) int
	}

	Subscription struct {
		OnGameEnd           func(childComplexity int, gameID string) int
		OnGameStart         func(childComplexity int, gameID string) int
		OnHandsChange       func(childComplexity int, gameID string) int
		OnLapEnd            func(childComplexity int, gameID string) int
		OnLapStart          func(childComplexity int, gameID string) int
		OnMoveEnd           func(childComplexity int, gameID string) int
		OnMoveStart         func(childComplexity int, gameID string) int
		OnPlayersSuitChange func(childComplexity int, gameID string) int
		OnRoundEnd          func(childComplexity int, gameID string) int
		OnRoundStart        func(childComplexity int, gameID string) int
		OnScoresChange      func(childComplexity int, gameID string) int
		OnTrumpSuitChange   func(childComplexity int, gameID string) int
		Ping                func(childComplexity int) int
		PingAuthorized      func(childComplexity int) int
	}

	SuccessMessage struct {
		Success func(childComplexity int) int
	}

	Team struct {
		ID      func(childComplexity int) int
		Players func(childComplexity int) int
	}

	TeamPoints struct {
		Points func(childComplexity int) int
		Team   func(childComplexity int) int
	}

	TeamScore struct {
		Score func(childComplexity int) int
		Team  func(childComplexity int) int
	}

	Tokens struct {
		Access  func(childComplexity int) int
		Refresh func(childComplexity int) int
	}

	User struct {
		Email    func(childComplexity int) int
		ID       func(childComplexity int) int
		Role     func(childComplexity int) int
		Username func(childComplexity int) int
	}

	UserPlayer struct {
		ID   func(childComplexity int) int
		Name func(childComplexity int) int
	}

	UserWithToken struct {
		Tokens func(childComplexity int) int
		User   func(childComplexity int) int
	}
}

type executableSchema struct {
	schema     *ast.Schema
	resolvers  ResolverRoot
	directives DirectiveRoot
	complexity ComplexityRoot
}

func (e *executableSchema) Schema() *ast.Schema {
	if e.schema != nil {
		return e.schema
	}
	return parsedSchema
}

func (e *executableSchema) Complexity(typeName, field string, childComplexity int, rawArgs map[string]interface{}) (int, bool) {
	ec := executionContext{nil, e, 0, 0, nil}
	_ = ec
	switch typeName + "." + field {

	case "BotPlayer.id":
		if e.complexity.BotPlayer.ID == nil {
			break
		}

		return e.complexity.BotPlayer.ID(childComplexity), true

	case "BotPlayer.name":
		if e.complexity.BotPlayer.Name == nil {
			break
		}

		return e.complexity.BotPlayer.Name(childComplexity), true

	case "Card.rank":
		if e.complexity.Card.Rank == nil {
			break
		}

		return e.complexity.Card.Rank(childComplexity), true

	case "Card.suit":
		if e.complexity.Card.Suit == nil {
			break
		}

		return e.complexity.Card.Suit(childComplexity), true

	case "Game.id":
		if e.complexity.Game.ID == nil {
			break
		}

		return e.complexity.Game.ID(childComplexity), true

	case "Game.teams":
		if e.complexity.Game.Teams == nil {
			break
		}

		return e.complexity.Game.Teams(childComplexity), true

	case "Game.winner":
		if e.complexity.Game.Winner == nil {
			break
		}

		return e.complexity.Game.Winner(childComplexity), true

	case "Hand.cards":
		if e.complexity.Hand.Cards == nil {
			break
		}

		return e.complexity.Hand.Cards(childComplexity), true

	case "Hand.player":
		if e.complexity.Hand.Player == nil {
			break
		}

		return e.complexity.Hand.Player(childComplexity), true

	case "Lap.id":
		if e.complexity.Lap.ID == nil {
			break
		}

		return e.complexity.Lap.ID(childComplexity), true

	case "Move.card":
		if e.complexity.Move.Card == nil {
			break
		}

		return e.complexity.Move.Card(childComplexity), true

	case "Move.id":
		if e.complexity.Move.ID == nil {
			break
		}

		return e.complexity.Move.ID(childComplexity), true

	case "Move.player":
		if e.complexity.Move.Player == nil {
			break
		}

		return e.complexity.Move.Player(childComplexity), true

	case "Mutation.createGame":
		if e.complexity.Mutation.CreateGame == nil {
			break
		}

		return e.complexity.Mutation.CreateGame(childComplexity), true

	case "Mutation.login":
		if e.complexity.Mutation.Login == nil {
			break
		}

		args, err := ec.field_Mutation_login_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Mutation.Login(childComplexity, args["email"].(string), args["password"].(string)), true

	case "Mutation.move":
		if e.complexity.Mutation.Move == nil {
			break
		}

		args, err := ec.field_Mutation_move_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Mutation.Move(childComplexity, args["gameID"].(string), args["card"].(*model.InputCard)), true

	case "Mutation.ping":
		if e.complexity.Mutation.Ping == nil {
			break
		}

		return e.complexity.Mutation.Ping(childComplexity), true

	case "Mutation.pingAuthorized":
		if e.complexity.Mutation.PingAuthorized == nil {
			break
		}

		return e.complexity.Mutation.PingAuthorized(childComplexity), true

	case "Mutation.refreshToken":
		if e.complexity.Mutation.RefreshToken == nil {
			break
		}

		args, err := ec.field_Mutation_refreshToken_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Mutation.RefreshToken(childComplexity, args["refreshToken"].(string)), true

	case "Mutation.register":
		if e.complexity.Mutation.Register == nil {
			break
		}

		args, err := ec.field_Mutation_register_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Mutation.Register(childComplexity, args["email"].(string), args["password"].(string)), true

	case "Mutation.startGame":
		if e.complexity.Mutation.StartGame == nil {
			break
		}

		args, err := ec.field_Mutation_startGame_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Mutation.StartGame(childComplexity, args["gameID"].(string)), true

	case "PlayerSuit.player":
		if e.complexity.PlayerSuit.Player == nil {
			break
		}

		return e.complexity.PlayerSuit.Player(childComplexity), true

	case "PlayerSuit.suit":
		if e.complexity.PlayerSuit.Suit == nil {
			break
		}

		return e.complexity.PlayerSuit.Suit(childComplexity), true

	case "Query.getUser":
		if e.complexity.Query.GetUser == nil {
			break
		}

		args, err := ec.field_Query_getUser_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Query.GetUser(childComplexity, args["id"].(*string)), true

	case "Query.hands":
		if e.complexity.Query.Hands == nil {
			break
		}

		args, err := ec.field_Query_hands_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Query.Hands(childComplexity, args["gameId"].(string)), true

	case "Query.ping":
		if e.complexity.Query.Ping == nil {
			break
		}

		return e.complexity.Query.Ping(childComplexity), true

	case "Query.pingAuthorized":
		if e.complexity.Query.PingAuthorized == nil {
			break
		}

		return e.complexity.Query.PingAuthorized(childComplexity), true

	case "Round.id":
		if e.complexity.Round.ID == nil {
			break
		}

		return e.complexity.Round.ID(childComplexity), true

	case "Round.teamsPoints":
		if e.complexity.Round.TeamsPoints == nil {
			break
		}

		return e.complexity.Round.TeamsPoints(childComplexity), true

	case "Round.winner":
		if e.complexity.Round.Winner == nil {
			break
		}

		return e.complexity.Round.Winner(childComplexity), true

	case "Subscription.onGameEnd":
		if e.complexity.Subscription.OnGameEnd == nil {
			break
		}

		args, err := ec.field_Subscription_onGameEnd_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnGameEnd(childComplexity, args["gameId"].(string)), true

	case "Subscription.onGameStart":
		if e.complexity.Subscription.OnGameStart == nil {
			break
		}

		args, err := ec.field_Subscription_onGameStart_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnGameStart(childComplexity, args["gameId"].(string)), true

	case "Subscription.onHandsChange":
		if e.complexity.Subscription.OnHandsChange == nil {
			break
		}

		args, err := ec.field_Subscription_onHandsChange_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnHandsChange(childComplexity, args["gameId"].(string)), true

	case "Subscription.onLapEnd":
		if e.complexity.Subscription.OnLapEnd == nil {
			break
		}

		args, err := ec.field_Subscription_onLapEnd_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnLapEnd(childComplexity, args["gameId"].(string)), true

	case "Subscription.onLapStart":
		if e.complexity.Subscription.OnLapStart == nil {
			break
		}

		args, err := ec.field_Subscription_onLapStart_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnLapStart(childComplexity, args["gameId"].(string)), true

	case "Subscription.onMoveEnd":
		if e.complexity.Subscription.OnMoveEnd == nil {
			break
		}

		args, err := ec.field_Subscription_onMoveEnd_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnMoveEnd(childComplexity, args["gameId"].(string)), true

	case "Subscription.onMoveStart":
		if e.complexity.Subscription.OnMoveStart == nil {
			break
		}

		args, err := ec.field_Subscription_onMoveStart_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnMoveStart(childComplexity, args["gameId"].(string)), true

	case "Subscription.onPlayersSuitChange":
		if e.complexity.Subscription.OnPlayersSuitChange == nil {
			break
		}

		args, err := ec.field_Subscription_onPlayersSuitChange_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnPlayersSuitChange(childComplexity, args["gameId"].(string)), true

	case "Subscription.onRoundEnd":
		if e.complexity.Subscription.OnRoundEnd == nil {
			break
		}

		args, err := ec.field_Subscription_onRoundEnd_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnRoundEnd(childComplexity, args["gameId"].(string)), true

	case "Subscription.onRoundStart":
		if e.complexity.Subscription.OnRoundStart == nil {
			break
		}

		args, err := ec.field_Subscription_onRoundStart_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnRoundStart(childComplexity, args["gameId"].(string)), true

	case "Subscription.onScoresChange":
		if e.complexity.Subscription.OnScoresChange == nil {
			break
		}

		args, err := ec.field_Subscription_onScoresChange_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnScoresChange(childComplexity, args["gameId"].(string)), true

	case "Subscription.onTrumpSuitChange":
		if e.complexity.Subscription.OnTrumpSuitChange == nil {
			break
		}

		args, err := ec.field_Subscription_onTrumpSuitChange_args(context.TODO(), rawArgs)
		if err != nil {
			return 0, false
		}

		return e.complexity.Subscription.OnTrumpSuitChange(childComplexity, args["gameId"].(string)), true

	case "Subscription.ping":
		if e.complexity.Subscription.Ping == nil {
			break
		}

		return e.complexity.Subscription.Ping(childComplexity), true

	case "Subscription.pingAuthorized":
		if e.complexity.Subscription.PingAuthorized == nil {
			break
		}

		return e.complexity.Subscription.PingAuthorized(childComplexity), true

	case "SuccessMessage.success":
		if e.complexity.SuccessMessage.Success == nil {
			break
		}

		return e.complexity.SuccessMessage.Success(childComplexity), true

	case "Team.id":
		if e.complexity.Team.ID == nil {
			break
		}

		return e.complexity.Team.ID(childComplexity), true

	case "Team.players":
		if e.complexity.Team.Players == nil {
			break
		}

		return e.complexity.Team.Players(childComplexity), true

	case "TeamPoints.points":
		if e.complexity.TeamPoints.Points == nil {
			break
		}

		return e.complexity.TeamPoints.Points(childComplexity), true

	case "TeamPoints.team":
		if e.complexity.TeamPoints.Team == nil {
			break
		}

		return e.complexity.TeamPoints.Team(childComplexity), true

	case "TeamScore.score":
		if e.complexity.TeamScore.Score == nil {
			break
		}

		return e.complexity.TeamScore.Score(childComplexity), true

	case "TeamScore.team":
		if e.complexity.TeamScore.Team == nil {
			break
		}

		return e.complexity.TeamScore.Team(childComplexity), true

	case "Tokens.access":
		if e.complexity.Tokens.Access == nil {
			break
		}

		return e.complexity.Tokens.Access(childComplexity), true

	case "Tokens.refresh":
		if e.complexity.Tokens.Refresh == nil {
			break
		}

		return e.complexity.Tokens.Refresh(childComplexity), true

	case "User.email":
		if e.complexity.User.Email == nil {
			break
		}

		return e.complexity.User.Email(childComplexity), true

	case "User.id":
		if e.complexity.User.ID == nil {
			break
		}

		return e.complexity.User.ID(childComplexity), true

	case "User.role":
		if e.complexity.User.Role == nil {
			break
		}

		return e.complexity.User.Role(childComplexity), true

	case "User.username":
		if e.complexity.User.Username == nil {
			break
		}

		return e.complexity.User.Username(childComplexity), true

	case "UserPlayer.id":
		if e.complexity.UserPlayer.ID == nil {
			break
		}

		return e.complexity.UserPlayer.ID(childComplexity), true

	case "UserPlayer.name":
		if e.complexity.UserPlayer.Name == nil {
			break
		}

		return e.complexity.UserPlayer.Name(childComplexity), true

	case "UserWithToken.tokens":
		if e.complexity.UserWithToken.Tokens == nil {
			break
		}

		return e.complexity.UserWithToken.Tokens(childComplexity), true

	case "UserWithToken.user":
		if e.complexity.UserWithToken.User == nil {
			break
		}

		return e.complexity.UserWithToken.User(childComplexity), true

	}
	return 0, false
}

func (e *executableSchema) Exec(ctx context.Context) graphql.ResponseHandler {
	rc := graphql.GetOperationContext(ctx)
	ec := executionContext{rc, e, 0, 0, make(chan graphql.DeferredResult)}
	inputUnmarshalMap := graphql.BuildUnmarshalerMap(
		ec.unmarshalInputInputCard,
	)
	first := true

	switch rc.Operation.Operation {
	case ast.Query:
		return func(ctx context.Context) *graphql.Response {
			var response graphql.Response
			var data graphql.Marshaler
			if first {
				first = false
				ctx = graphql.WithUnmarshalerMap(ctx, inputUnmarshalMap)
				data = ec._Query(ctx, rc.Operation.SelectionSet)
			} else {
				if atomic.LoadInt32(&ec.pendingDeferred) > 0 {
					result := <-ec.deferredResults
					atomic.AddInt32(&ec.pendingDeferred, -1)
					data = result.Result
					response.Path = result.Path
					response.Label = result.Label
					response.Errors = result.Errors
				} else {
					return nil
				}
			}
			var buf bytes.Buffer
			data.MarshalGQL(&buf)
			response.Data = buf.Bytes()
			if atomic.LoadInt32(&ec.deferred) > 0 {
				hasNext := atomic.LoadInt32(&ec.pendingDeferred) > 0
				response.HasNext = &hasNext
			}

			return &response
		}
	case ast.Mutation:
		return func(ctx context.Context) *graphql.Response {
			if !first {
				return nil
			}
			first = false
			ctx = graphql.WithUnmarshalerMap(ctx, inputUnmarshalMap)
			data := ec._Mutation(ctx, rc.Operation.SelectionSet)
			var buf bytes.Buffer
			data.MarshalGQL(&buf)

			return &graphql.Response{
				Data: buf.Bytes(),
			}
		}
	case ast.Subscription:
		next := ec._Subscription(ctx, rc.Operation.SelectionSet)

		var buf bytes.Buffer
		return func(ctx context.Context) *graphql.Response {
			buf.Reset()
			data := next(ctx)

			if data == nil {
				return nil
			}
			data.MarshalGQL(&buf)

			return &graphql.Response{
				Data: buf.Bytes(),
			}
		}

	default:
		return graphql.OneShot(graphql.ErrorResponse(ctx, "unsupported GraphQL operation"))
	}
}

type executionContext struct {
	*graphql.OperationContext
	*executableSchema
	deferred        int32
	pendingDeferred int32
	deferredResults chan graphql.DeferredResult
}

func (ec *executionContext) processDeferredGroup(dg graphql.DeferredGroup) {
	atomic.AddInt32(&ec.pendingDeferred, 1)
	go func() {
		ctx := graphql.WithFreshResponseContext(dg.Context)
		dg.FieldSet.Dispatch(ctx)
		ds := graphql.DeferredResult{
			Path:   dg.Path,
			Label:  dg.Label,
			Result: dg.FieldSet,
			Errors: graphql.GetErrors(ctx),
		}
		// null fields should bubble up
		if dg.FieldSet.Invalids > 0 {
			ds.Result = graphql.Null
		}
		ec.deferredResults <- ds
	}()
}

func (ec *executionContext) introspectSchema() (*introspection.Schema, error) {
	if ec.DisableIntrospection {
		return nil, errors.New("introspection disabled")
	}
	return introspection.WrapSchema(ec.Schema()), nil
}

func (ec *executionContext) introspectType(name string) (*introspection.Type, error) {
	if ec.DisableIntrospection {
		return nil, errors.New("introspection disabled")
	}
	return introspection.WrapTypeFromDef(ec.Schema(), ec.Schema().Types[name]), nil
}

var sources = []*ast.Source{
	{Name: "../schema/auth/auth.model.graphql", Input: `type Tokens {
  access: String!
  refresh: String!
}

type UserWithToken {
  user: User!
  tokens: Tokens!
}
`, BuiltIn: false},
	{Name: "../schema/auth/auth.mutation.graphql", Input: `extend type Mutation {
  login(email: String!, password: String!): UserWithToken!
  register(email: String!, password: String!): User!
  refreshToken(refreshToken: String!): Tokens!
}
`, BuiltIn: false},
	{Name: "../schema/game/game.model.graphql", Input: `type Game {
  id: ID!
#  rounds: [Round!]!
  teams: [Team!]!
  winner: Team
}

type Round {
  id: ID!
#  game: Game!
#  laps: [Lap!]!
  teamsPoints: [TeamPoints!]!
  winner: Team
}

type Lap {
  id: ID!
#  round: Round!
#  moves: [Move!]!
}

type Move {
  id: ID!
#  lap: Lap!
  player: Player!
  card: Card!
}

type Team {
  id: ID!
  players: [Player!]!
}

interface Player {
  id: ID!
  name: String!
}

type UserPlayer implements Player{
  id: ID!
  name: String!
}

type BotPlayer implements Player{
  id: ID!
  name: String!
}

type Hand {
  player: Player!
  cards: [Card]!
}

type Card {
  rank: Rank!
  suit: Suit!
}

type PlayerSuit {
  player: Player!
  suit: Suit!
}

type TeamScore {
  team: Team!
  score: Score!
}

type TeamPoints {
  team: Team!
  points: Points!
}
`, BuiltIn: false},
	{Name: "../schema/game/game.mutation.graphql", Input: `extend type Mutation {
  createGame: Game!
  startGame(gameID: String!): SuccessMessage
  move(gameID: String!, card: InputCard): SuccessMessage
}

input InputCard {
  suit: Suit
  rank: Rank
}
`, BuiltIn: false},
	{Name: "../schema/game/game.query.graphql", Input: `extend type Query {
  hands(gameId: ID!): [Hand!]!
}
`, BuiltIn: false},
	{Name: "../schema/game/game.subscription.graphql", Input: `extend type Subscription {
  onGameStart(gameId: String!): Game!
  onPlayersSuitChange(gameId: String!): [PlayerSuit!]!
  onScoresChange(gameId: String!): [TeamScore!]!
  onGameEnd(gameId: String!): Game!
  onRoundStart(gameId: String!): Round!
  onTrumpSuitChange(gameId: String!): Suit!
  onHandsChange(gameId: String!): [Hand!]!
  onRoundEnd(gameId: String!): Round!
  onLapStart(gameId: String!): Lap!
  onLapEnd(gameId: String!): Lap!
  onMoveStart(gameId: String!): Move!
  onMoveEnd(gameId: String!): Move!
}
`, BuiltIn: false},
	{Name: "../schema/mutation.graphql", Input: `type Mutation {
  ping: String # this is so that we can define base type without compiler complaining
  pingAuthorized: String @allowAccess(roles: [User, Admin])
}
`, BuiltIn: false},
	{Name: "../schema/query.graphql", Input: `type Query {
  ping: String # this is so that we can define base type without compiler complaining
  pingAuthorized: String @allowAccess(roles: [User, Admin])
}
`, BuiltIn: false},
	{Name: "../schema/shared/response.graphql", Input: `type SuccessMessage {
    success: Boolean
}
`, BuiltIn: false},
	{Name: "../schema/shared/role.graphql", Input: `directive @allowAccess(roles: [Role!]!) on FIELD_DEFINITION

enum Role {
  Admin
  User
}
`, BuiltIn: false},
	{Name: "../schema/shared/scalars.graphql", Input: `scalar Time

"""
The ` + "`" + `Suit` + "`" + ` scalar type represents card's suit. ` + "`" + `Int` + "`" + ` from ` + "`" + `0` + "`" + ` to ` + "`" + `3` + "`" + `
0 - ♦️
1 - ♥️
2 - ♠️
3 - ♣️
"""
scalar Suit

"""
The ` + "`" + `Rank` + "`" + ` scalar type represents card's rank. ` + "`" + `Int` + "`" + ` from ` + "`" + `0` + "`" + ` to ` + "`" + `7` + "`" + `
0 - 7
1 - 8
2 - 9
3 - 10
4 - J
5 - Q
6 - K
7 - A
"""
scalar Rank

"""
The ` + "`" + `Score` + "`" + ` scalar type represents team's score per game. ` + "`" + `Int` + "`" + ` from ` + "`" + `0` + "`" + ` to ` + "`" + `12` + "`" + `
"""
scalar Score

"""
The ` + "`" + `Points` + "`" + ` scalar type represents team's points per lap. ` + "`" + `Int` + "`" + ` from ` + "`" + `0` + "`" + ` to ` + "`" + `120` + "`" + `
"""
scalar Points
`, BuiltIn: false},
	{Name: "../schema/subscription.graphql", Input: `type Subscription {
  ping: String # this is so that we can define base type without compiler complaining
  pingAuthorized: String @allowAccess(roles: [User, Admin])
}
`, BuiltIn: false},
	{Name: "../schema/user/user.model.graphql", Input: `type User {
  id: ID!
  email: String!
  username: String!
  role: Role!
}
`, BuiltIn: false},
	{Name: "../schema/user/user.query.graphql", Input: `extend type Query {
  getUser(id: ID): User
}
`, BuiltIn: false},
}
var parsedSchema = gqlparser.MustLoadSchema(sources...)
